#include "testlib.h"
#include <unordered_set>

using namespace std;

int n;

int readAndCheckAnswer(InStream& in) {
    string ans = in.readLine("[0-1]{1,2000000}", "answer");
    if ((int) ans.size() != (1 << n))
        in.quitf(_wa, "Expected string with length 2^n=%d, but actual length is %d", 1 << n, (int) ans.size());
    unordered_set <string> s;
    for (int len = 1; len <= (1 << n); len *= 2) {
        for (int i = 0; i < (1 << n); i += len) {
            string cur = "";
            for (int j = 0; j < len; j++)
                cur += ans[i + j];
            s.insert(cur);
        }
    }
    return s.size();
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    int ja = readAndCheckAnswer(ans);
    int pa = readAndCheckAnswer(ouf);
    if (ja < pa)
        quitf(_fail, "Paticipant has better answer than jury: ja=%d, pa=%d", ja, pa);
    if (ja > pa)
        quitf(_wa, "Jury has better answer then participant: ja=%d, pa=%d", ja, pa);
    quitf(_ok, "ja=%d, pa=%d", ja, pa);
}
