#include <iostream>
#include <unordered_set>
#include <cassert>

using namespace std;

const int MAX_N = 20;

int safe_pow2(int k) {
    return 1 << min(MAX_N + 3, k);
}

bool is_optimal(int n, string &s) {
    int sz = 1 << n;
    for (int level = 0; level <= n; level++) {
        int len = 1 << level;
        int best_possible = min(sz / len, safe_pow2(len));
        unordered_set <string> diff;
        for (int i = 0; i < sz; i += len) {
            string cur = "";
            for (int j = 0; j < len; j++)
                cur += s[i + j];
            diff.insert(cur);
        }
        if ((int) diff.size() != best_possible)
            return 0;
    }
    return 1;
}

void get_next(string &s) {
    int sz = s.size();
    for (int i = sz - 1; i >= 0; i--) {
        s[i] ^= 1;
        if (s[i] == '1')
            return;
    }
    assert(0);
}


signed main() {
    int n;
    cin >> n;
    int cur_len = 1, cnt = 1 << n;
    string s = "";
    while (safe_pow2(cur_len) <= cnt) {
        cnt /= 2;
        cur_len *= 2;
    }
    cur_len /= 2;
    for (int mask = 0; mask < (1 << cur_len); mask++) {
        for (int i = 0; i < cur_len; i++) {
            if (mask & (1 << i))
                s += "1";
            else
                s += "0";
        }
    }
    cur_len *= 2;
    string str_to_add;
    for (int i = 0; i < cur_len; i++)
        str_to_add += "0";
    unordered_set <string> has;
    for (int i = 0; i < (int) s.size(); i += cur_len) {
        string cur = "";
        for (int j = 0; j < cur_len; j++)
            cur += s[i + j];
        has.insert(cur);
    }
    while ((int) s.size() != (1 << n)) {
        while (has.find(str_to_add) != has.end())
            get_next(str_to_add);
        has.insert(str_to_add);
        s += str_to_add;
    }
    assert(is_optimal(n, s));
    cout << s << endl;
}
