#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 20;

int safe_pow2(int k) {
    return 1 << min(MAX_N + 3, k);
}

bool is_optimal(int n, string &s) {
    int sz = 1 << n;
    for (int level = 0; level <= n; level++) {
        int len = 1 << level;
        int best_possible = min(sz / len, safe_pow2(len));
        unordered_set <string> diff;
        for (int i = 0; i < sz; i += len) {
            string cur = "";
            for (int j = 0; j < len; j++)
                cur += s[i + j];
            diff.insert(cur);
        }
        if ((int) diff.size() != best_possible)
            return 0;
    }
    return 1;
}

signed main() {
    int n;
    cin >> n;
    string s = "";
    mt19937 rnd(239);
    while (1) {
        s = "";
        for (int i = 0; i < (1 << n); i++)
            s += '0' + rnd() % 2;
        if (is_optimal(n, s)) {
            cout << s << endl;
            return 0;
        }
    }
}
