// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	int m = opt<int>(2);
	int k = opt<int>(3);

	vector<vector<char>> field(n, vector<char>(m, '.'));

	for (int i = 0, j = 0; i < 1000000 && j < k; ++i) {
		int szx = 1, szy = 2;
		if (rnd.next()) {
			swap(szx, szy);
		}

		if (szx > n || szy > m) {
			continue;
		}

		int sx = rnd.next(0, n - szx);
		int sy = rnd.next(0, m - szy);

		bool ok = true;
		vector<pii> cells;
		for (int x = sx; x < sx + szx; ++x) {
			for (int y = sy; y < sy + szy; ++y) {
				cells.push_back({x, y});
				if (field[x][y] != '.') {
					ok = false;
					break;
				}
			}
			if (!ok) {
				break;
			}
		}

		if (!ok) {
			continue;
		}

		++j;

		set<char> neib_cols;
		for (auto [x, y] : cells) {
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && field[nx][ny] != '.') {
					neib_cols.insert(field[nx][ny]);
				}
			}
		}

		char col;

		while (true) {
			if (rnd.next(0, 1)) {
				col = rnd.next('a', 'z');
			} else {
				col = rnd.next('A', 'Z');
			}
			if (!neib_cols.count(col)) {
				break;
			}
		}

		for (auto [x, y] : cells) {
			field[x][y] = col;
		}
	}

	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << field[i][j];
		}
		cout << "\n";
	}

	return 0;
}