// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXN = 1000;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXN, "m");
	inf.readEoln();

	vector<string> field;

	for (int i = 0; i < n; ++i) {
		field.push_back(inf.readLine(format("[a-zA-Z.]{%d}", m), format("s_%d", i + 1)));
	}

	inf.readEof();

	vector<vector<bool>> used(n, vector<bool>(m));

	function<int(int, int)> dfs = [&](int x, int y) {
		used[x][y] = true;
		int ret = 1;
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < m && !used[nx][ny] && field[nx][ny] == field[x][y]) {
				ret += dfs(nx, ny);
			}
		}
		return ret;
	};

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!used[i][j] && field[i][j] != '.') {
				ensuref(dfs(i, j) == 2, "every connected component should contain exactly 2 cells");
			}
		}
	}

	return 0;
}