import java.lang.StringBuilder
 
fun main() {
    val (hei, wid) = readInts()
    val field = List(hei) { readLn() }
    val wanted = List(hei) { List(wid) { mutableListOf<Int>() } }
    for (i in 0 until hei) {
        for (j in 0 until wid) {
            val id = i * wid + j
            if (field[i][j] == '.') continue
            for (dir in 0..1) {
                val i2 = i + DX[dir]; val j2 = j + DY[dir]
                if (i2 >= hei || j2 >= wid || field[i2][j2] != field[i][j]) continue
                wanted[i][j].add(id)
                wanted[i2][j2].add(id)
                val k = if (field[i][j].isUpperCase()) 1 else -1
                val weWant = mutableListOf<Pair<Int, Int>>()
                for (t in 0..1) {
                    val i3 = i + t * DX[dir] + k * DY[dir]
                    val j3 = j + t * DY[dir] + k * DX[dir]
                    if (i3 in 0 until hei && j3 in 0 until wid && field[i3][j3] == '.') weWant.add(i3 to j3)
                }
                if (weWant.size != 2) continue
                weWant.forEach { wanted[it.first][it.second].add(id) }
            }
        }
    }
    val nei = List(hei * wid) { mutableSetOf<Int>() }
    for (i in 0 until hei) {
        for (j in 0 until wid) {
            if (wanted[i][j].size != 2) continue
            val (a, b) = wanted[i][j]
            nei[a].add(b); nei[b].add(a)
        }
    }
    val color = IntArray(hei * wid)
    for (i in 0 until hei * wid) {
        if (color[i] > 0 || nei[i].isEmpty()) continue
        var j = i
        var prev = -1
        while (true) {
            val next = nei[j].firstOrNull { it != prev && it != i } ?: break
            prev = j
            j = next
        }
        color[j] = 1
        val jInit = j
        prev = -1
        while (true) {
            val next = nei[j].firstOrNull { it != prev && it != jInit } ?: break
            color[next] = 3 - color[j]
            prev = j
            j = next
        }
    }
    val open = mutableSetOf<Int>()
    val digit = IntArray(hei * wid) { -1 }
    val ans = List(hei) { i ->
        List(wid) { j ->
            val id = if (field[i][j] != '.') {
                wanted[i][j].first()
            } else {
                wanted[i][j].firstOrNull { color[it] != 2 }?.also { open.add(it) } ?: -1
            }
            if (id == -1) '.' else {
                if (digit[id] == -1) {
                    digit[id] = 3 * (i % 3) + j % 3
                }
                digit[id]
            }
        }.joinToString("")
    }
    println(open.size)
    println(ans.joinToString("\n"))
}
 
private val DX = intArrayOf(1, 0, -1, 0)
private val DY = intArrayOf(0, 1, 0, -1)
 
private fun readLn() = readLine()!!
private fun readInt() = readLn().toInt()
private fun readStrings() = readLn().split(" ")
private fun readInts() = readStrings().map { it.toInt() }
