// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

int dx[4] = {0, 1, 0, -1};
int dy[4] = {1, 0, -1, 0};

bool is_cap(char c) {
	return 'A' <= c && c <= 'Z';
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> field(n, vector<char>(m));

	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j];
		}
	}

	vector<vector<pii>> couches;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j] == '.') {
				continue;
			}
			if (i + 1 < n && field[i][j] == field[i + 1][j]) {
				if (is_cap(field[i][j])) {
					couches.push_back({{i, j}, {i + 1, j}, {i, j + 1}, {i + 1, j + 1}});
				} else {
					couches.push_back({{i, j}, {i + 1, j}, {i, j - 1}, {i + 1, j - 1}});
				}
			}
			if (j + 1 < m && field[i][j] == field[i][j + 1]) {
				if (is_cap(field[i][j])) {
					couches.push_back({{i, j}, {i, j + 1}, {i + 1, j}, {i + 1, j + 1}});
				} else {
					couches.push_back({{i, j}, {i, j + 1}, {i - 1, j}, {i - 1, j + 1}});
				}
			}
		}
	}

	vector<vector<vector<int>>> here(n, vector<vector<int>>(m));

	vector<bool> good_couch(szof(couches));

	auto is_empty = [&](pii p) {
		return 0 <= p.ff && p.ff < n && 0 <= p.ss && p.ss < m && field[p.ff][p.ss] == '.';
	};

	for (int i = 0; i < szof(couches); ++i) {
		auto& p = couches[i];
		if (is_empty(p[2]) && is_empty(p[3])) {
			good_couch[i] = true;
			here[p[2].ff][p[2].ss].push_back(i);
			here[p[3].ff][p[3].ss].push_back(i);
		}
	}

	vector<vector<int>> graph(szof(couches));

	for (int x = 0; x < n; ++x) {
		for (int y = 0; y < m; ++y) {
			assert(szof(here[x][y]) <= 2);
			if (szof(here[x][y]) == 2) {
				int a = here[x][y][0];
				int b = here[x][y][1];
				graph[a].push_back(b);
				graph[b].push_back(a);
			}
		}
	}

	vector<int> path;
	vector<bool> used(szof(couches));

	function<void(int)> dfs = [&](int v) {
		used[v] = true;
		path.push_back(v);
		for (int to : graph[v]) {
			if (!used[to]) {
				dfs(to);
			}
		}
	};

	vector<bool> ans(szof(couches));

	for (int qwe = 1; qwe <= 2; ++qwe) {
		for (int i = 0; i < szof(couches); ++i) {
			if (good_couch[i] && !used[i] && szof(graph[i]) <= qwe) {
				path.clear();
				dfs(i);
				for (int j = 0; j < szof(path); j += 2) {
					ans[path[j]] = true;
				}
			}
		}
	}

	vector<vector<char>> outp(n, vector<char>(m, '.'));
	vector<bool> color_used(10);

	for (int i = 0; i < szof(couches); ++i) {
		auto& cur = couches[i];
		if (!good_couch[i] || !ans[i]) {
			cur.resize(2);
		}

		fill(color_used.begin(), color_used.end(), 0);

		for (auto p : cur) {
			for (int d = 0; d < 4; ++d) {
				int nx = p.ff + dx[d];
				int ny = p.ss + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && outp[nx][ny] != '.') {
					color_used[outp[nx][ny] - '0'] = true;
				}
			}
		}

		int col = find(color_used.begin(), color_used.end(), 0) - color_used.begin();
		for (auto p : cur) {
			outp[p.ff][p.ss] = '0' + col;
		}
	}

	cout << accumulate(ans.begin(), ans.end(), 0) << "\n";

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cout << outp[i][j];
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}