#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

#define x first 
#define y second

int n;
vector<pair<int, int>> p;

vector<pair<int, int>> segs;

void makeMove(int u, int v, bool myTurn) {
    if (u > v) {
        int t = u; u = v; v = t;
    }
    segs.push_back({u, v});
    if (myTurn) {
        cout << u + 1 << " " << v + 1 << endl;
    }
}

long long vp(long long x1, long long y1, long long x2, long long y2) {
    return x1 * y2 - x2 * y1;
}

bool intersect(long long x1, long long y1, long long x2, long long y2, long long x3, long long y3, long long x4, long long y4) {
    long long vp13 = vp(x2 - x1, y2 - y1, x3 - x1, y3 - y1);
    long long vp14 = vp(x2 - x1, y2 - y1, x4 - x1, y4 - y1);
    long long vp31 = vp(x4 - x3, y4 - y3, x1 - x3, y1 - y3);
    long long vp32 = vp(x4 - x3, y4 - y3, x2 - x3, y2 - y3);
    bool g1 = (vp13 < 0 && vp14 > 0) || (vp13 > 0 && vp14 < 0);
    bool g2 = (vp31 < 0 && vp32 > 0) || (vp31 > 0 && vp32 < 0);
    return g1 && g2;
}

set<pair<int, int>> memo;

bool validMove(int u, int v) {
    if (u > v) {
        int t = u; u = v; v = t;
    }
    if (memo.count({u, v}) != 0) {
        return false;
    }
    memo.insert({u, v});
    for (int i = 0; i < segs.size(); i++) {
        if (u == segs[i].x && v == segs[i].y) {
            return false;
        }
        if (u == segs[i].x || v == segs[i].y) {
            continue;
        }
        if (intersect(p[u].x, p[u].y, p[v].x, p[v].y, p[segs[i].x].x, p[segs[i].x].y, p[segs[i].y].x, p[segs[i].y].y)) {
            return false;
        }
    }
    return true;
}

void checkValid(int u, int v) {
    if (u > v) {
        int t = u; u = v; v = t;
    }
    for (int i = 0; i < segs.size(); i++) {
        if (u == segs[i].x && v == segs[i].y) {
            quitf(_wa, "segment %d %d is already there", u + 1, v + 1);
        }
        if (u == segs[i].x || v == segs[i].y) {
            continue;
        }
        if (intersect(p[u].x, p[u].y, p[v].x, p[v].y, p[segs[i].x].x, p[segs[i].x].y, p[segs[i].y].x, p[segs[i].y].y)) {
            quitf(_wa, "segment %d %d itersects segment %d %d", u + 1, v + 1, segs[i].x + 1, segs[i].y + 1);
        }
    }
}

void minMove() {
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (validMove(i, j)) {
                makeMove(i, j, true);
                return;
            }
        }
    }
}

void maxMove() {
    for (int i = n - 1; i >= 0; i--) {
        for (int j = n - 1; j > i; j--) {
            if (validMove(i, j)) {
                makeMove(i, j, true);
                return;
            }
        }
    }
}

vector<pair<int, int>> allowed;

void rndMove() {
    while (true) {
        int p = rnd.next(0, (int) allowed.size() - 1);
        int i = allowed[p].x;
        int j = allowed[p].y;
        if (validMove(i, j)) {
            makeMove(i, j, true);
            return;
        }
        allowed[p] = allowed[allowed.size() - 1];
        allowed.resize(allowed.size() - 1);
    }
}

int main(int argc, char** argv) {
    registerInteraction(argc, argv);
    
    n = inf.readInt();
    cout << n << endl;
    p.resize(n);    
    for (int i = 0; i < n; i++) {
        p[i].x = inf.readInt();
        p[i].y = inf.readInt();
        cout << p[i].x << " " << p[i].y << endl;
    }

    int cc = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            long long a = p[i].y - p[j].y;
            long long b = p[j].x - p[i].x;
            long long c = -a * p[i].x - b * p[i].y;

            int pos = 0;
            int neg = 0;
            for (int k = 0; k < n; k++) {
                if (a * p[k].x + b * p[k].y + c > 0) pos++;
                if (a * p[k].x + b * p[k].y + c < 0) neg++;
            }

            if (pos == 0 || neg == 0) {
                cc++;
            }
        }
    }    

    /* 
        n + f - e = 2
        3f - 3 + c = 2e

        f = 2 + e - n

        6 + 3e - 3n - 3 + c = 2e
        e = 3n - 3 - c
    */
    int e = 3 * n - 3 - cc;

    int first = ouf.readInt(1, 2);
    if (first % 2 != e % 2) {
        quitf(_wa, "planning to play wrong party, expected %d, found %d", 2 - e % 2, 2 - first % 2);
    }

    bool myturn = first == 2;

    int strategy = inf.readInt();
    if (strategy == 3) {
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                allowed.push_back({i, j});
            }
        }
    }

    while (e > 0) {
        if (myturn) {
            switch (strategy) {
                case 1:
                    minMove();
                    break;
                default:
                    ensuref(false, "invalid strategy %d", strategy);
                case 2:
                    maxMove();
                    break;
                case 3:
                    rndMove();
                    break;
            }
        } else {
            int u, v;
            u = ouf.readInt(1, n) - 1;
            v = ouf.readInt(1, n) - 1;
            if (u == v) {
                quitf(_wa, "segment %d-%d", u + 1, v + 1);
            }
            checkValid(u, v);
            makeMove(u, v, false);
        }
        e--;
        myturn = !myturn;
    }

    cout << 0 << " " << 0 << endl;
    quitf(_ok, "%d turns", 3 * n - 3 - cc);
}
