#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 500500;
//const int N = 505;
int n, m, k;
int c[N];
vector<int> a[N];
int par[N];
vector<int> g[N];
int ed[N][2];
priority_queue<pii> setik;

int getOther(int id, int v) {
	return v ^ ed[id][0] ^ ed[id][1];
}

int getCost(int id) {
	int w = c[ed[id][0]] - c[ed[id][1]];
	if (w < 0) w += k;
	//assert(w > 0);
	return min(w, k - w);
}

void addEdge(int id) {
	int w = getCost(id);
	setik.push(mp(-w, id));
}


int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d%d%d", &n, &m, &k);
	for (int i = 0; i < n; i++) {
		scanf("%d", &c[i]);
		c[i]--;
		par[i] = i;
		a[i].push_back(i);
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2; j++) {
			scanf("%d", &ed[i][j]);
			ed[i][j]--;
			g[ed[i][j]].push_back(i);
		}
		addEdge(i);
	}
	while(!setik.empty()) {
		int id = setik.top().second;
		int w = setik.top().first;
		setik.pop();
		if (-w != getCost(id)) continue;
		int v = ed[id][0], u = ed[id][1];
		int V = par[v], U = par[u];
		if (V == U) continue;
		//eprintf("v = %d, u = %d, V = %d, U = %d\n", v, u, V, U);
		assert(V != U);
		if ((int)a[V].size() < (int)a[U].size()) {
			swap(V, U);
			swap(v, u);
		}
		int sh = c[v] - c[u];
		if (sh < 0) sh += k;
		if (sh < k - sh)
			sh--;
		else
			sh++;
		//eprintf("sh = %d\n", sh);
		/*
		for (int w : a[U])
			for (int t : g[w]) {
				int z = getOther(t, w);
				if (par[z] == par[w]) continue;
				remEdge(t);
			}
		*/
		for (int w : a[U]) {
			a[V].push_back(w);
			par[w] = V;
			c[w] = (c[w] + sh) % k;
		}
		for (int w : a[U])
			for (int t : g[w]) {
				int z = getOther(t, w);
				if (par[z] == par[w]) continue;
				addEdge(t);
			}
	}
	for (int i = 0; i < n; i++)
		printf("%d ", c[i] + 1);
	printf("\n");

	return 0;
}
