#include <cstdio>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <functional>
#include <algorithm>
#include <numeric>

#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <W> <n_small> <n>");
	puts("  [seed == 0] => Time()");
	puts("  generates big anti greedy test");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, W);
	GET(int, n_small);
	GET(int, n);

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);

	int small = W / 5;
	int big = 3 * W / 4 + 1;

	while (tn--) {
		printf("%d %d\n", n, W);
		vector<pair<int, int>> test;

		int n0 = n_small;
		vector<int> p(n0 + 1);
		forn(i, n0 + 1)
			p[i] = R(0, small - n0);
		sort(all(p));
		forn(i, n0 + 1)
			p[i] += i;
		p[0] = 0, p[n0] = small;

		forn(i, n0) {
			int w = p[i + 1] - p[i];
			test.emplace_back(w, w * 2);
		}

		test.emplace_back(1, 2 * W);

		int too_big_w = 3 * W / 2 + 1;
		test.emplace_back(too_big_w, 1e6);

		forn(i, n - n_small - 2) {
			test.emplace_back(big + i, 2 * big + i);
		}

		randomShuffle(all(test));
		for (auto [a, b] : test)
			printf("%d %d\n", a, b);
	}
}
