/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#define _GLIBCXX_DEBUG
#define DEBUG 1

#include <bits/stdc++.h>
#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <n>");
	puts("  [seed == 0] => Time()");
	puts("  W=n");
	puts("  big costs: W*8/10 (bit better by cost/w), W*9/10");
	puts("  small costs: random small cost_i with w_i=1");
	puts("  optimal answer: best of W*9/10 + best small cost_i");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, n);
	int W = n;

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);
	while (tn--) {
		printf("%d %d\n", n, W);

		struct Item {
			int w, c, id;
		};

		// W1 + W2 > 3/2*W, W1 + W1 > 3/2*W, W1 < W2 < W
		int W1 = W * 8 / 10;
		int W2 = W * 9 / 10;

		const int K = 9;

		vector<Item> a, b;
		int id_cnt = 0;
		forn(i, n / 2)
			if (R(0, 1))
				// a.push_back({W1, (int)(W1 * (K+0.5)) - R(0, W1 / 2), id_cnt++});
				a.push_back({W1, (int)(W1 * (K+1./3)) - R(0, W1 / 3), id_cnt++});
			else
				// a.push_back({W2, W2 * K - R(0, W2 / 2), id_cnt++});
				a.push_back({W2, W2 * K - R(0, W2 / 3), id_cnt++});
		forn(i, n - n / 2)
			b.push_back({1, R(1, K - 1), id_cnt++});

		sort(all(a), [](Item a, Item b) {
			return a.w > b.w || (a.w == b.w && a.c > b.c);
		});
		sort(all(b), [](Item a, Item b) {
			return a.c > b.c;
		});

		vector<int> ans;
		int sum_w = 0;
		auto add = [&](Item a) {
			if (sum_w + a.w > W)
				return;
			sum_w += a.w;
			ans.push_back(a.id);
		};
		assert(a.size());
		add(a[0]);
		for (auto it : b)
			add(it);

		vector<Item> test = a;
		test.insert(test.end(), all(b));
		randomShuffle(all(test));
		vector<int> pos(id_cnt);
		forn(i, test.size()) {
			auto p = test[i];
			printf("%d %d\n", p.w, p.c), pos[p.id] = i;
		}
		W--;

		fprintf(stderr, "%d\n", (int)ans.size());
		for (int id : ans)
			fprintf(stderr, "%d ", pos[id] + 1);
		fprintf(stderr, "\n");
	}
}
