#include <cstdio>
#include <cassert>

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <functional>
#include <algorithm>
#include <numeric>

#include "random.h"

using namespace std;

int __id = 1, argc;
char **argv;
#define GET(type, var) if (__id >= argc) Usage(); type var; { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_GLOBAL(type, var) if (__id >= argc) Usage(); { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define GET_IF(type, var, default) type var; if (__id >= argc) var = default; else { std::stringstream ss(argv[__id++]); assert(ss >> (var)); }
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) (a).begin(), (a).end()

void Usage() {
	puts("Usage: <seed for random> <tn> <W> <n>");
	puts("  [seed == 0] => Time()");
	puts("  generates test anti sort(cost/w) + try worst one");
	exit(1);
}

int main(int _argc, char *_argv[]) {
	argc = _argc, argv = _argv;
	GET(int, seed);
	GET(int, tn);
	GET(int, W);
	GET(int, n);

	ios_base::sync_with_stdio(false), cin.tie(0);

	if (seed == 0)
		seed = Time(), fprintf(stderr, "seed = %u\n", seed);
	initrand(seed);

	printf("%d\n", tn);
	while (tn--) {
		printf("%d %d\n", n, W);
		vector<pair<int, int>> test;
		int a = W, b = W;
		forn(i, n) {
			test.push_back({a, b});
			if (i < n / 2)
				a -= 2, b--;
			else {
				if (i == n / 2)
					b = a;
				a--, b -= 2;
			}
		}
		if (tn % 3 == 0) randomShuffle(all(test));
		if (tn % 3 == 1) reverse(all(test));
		for (auto p : test)
			printf("%d %d\n", p.first, p.second);
		W--;
	}
}
