#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

int n;
ll W;
vector<pii> v;

void gen() {
  n = rand() % 14 + 1;
  W = rand() % 200 + 5;
  v.resize(n);
  for (auto &[w, c] : v) {
    w = rand() % (2 * W) + 1;
    c = rand() % 100 + 1;
  }
}

ll slow_solve(ll cur = 0, ll w = 0, int i = 0) {
  if (w > W) {
    return 0;
  }
  if (i == n) {
    return cur;
  }
  return max(slow_solve(cur + v[i].second, w + v[i].first, i + 1), slow_solve(cur, w, i + 1));
}

struct pp {
  int w, c, id;
};

void read() {
  cin >> n >> W;
  v.resize(n);
  for (auto&[w, c] : v) {
    cin >> w >> c;
  }
}

pair<ll, vector<int>> solve() {
  vector<pp> A;
  vector<pp> B;
  for (int i = 0; i < n; i++) {
    if (2 * v[i].first <= W) {
      A.push_back({v[i].first, v[i].second, i});
    } else {
      B.push_back({v[i].first, v[i].second, i});
    }
  }
  sort(A.begin(), A.end(), [](auto a, auto b) {
    return (ll) a.c * b.w > (ll) a.w * b.c;
  });
  sort(B.begin(), B.end(), [](auto a, auto b) {
    return a.w < b.w;
  });
  vector<pii> pref(B.size());
  for (int i = 0; i < (int) B.size(); i++) {
    if (i == 0) {
      pref[i] = {B[i].w, i};
    } else {
      pref[i] = pref[i - 1];
      if (B[i].c > B[pref[i].second].c) {
        pref[i] = {B[i].w, i};
      }
    }
  }

  ll sum = 0, w = 0;
  ll res = 0;
  vector<int> resIds;
  for (int i = 0; i < (int) A.size(); i++) {
    if (w + A[i].w <= 3 * W / 2) {
      w += A[i].w;
      sum += A[i].c;
    }
    res = max(res, sum);

    int l = -1, r = (int) pref.size();
    while (r - l > 1) {
      int m = (l + r) / 2;

      if (pref[m].first + w <= 3 * W / 2) {
        l = m;
      } else {
        r = m;
      }
    }

    if (l != -1) {
      res = max(res, sum + B[pref[l].second].c);
    }
  }

  for (int i = 0; i < B.size(); i++) {
    auto[_w, _c, _id] = B[i];
    if (_w <= 3 * W / 2 && res < _c) {
      res = _c;
      resIds = {B[i].id};
    }

    int l = -1, r = (int) B.size();
    while (r - l > 1) {
      int m = (l + r) / 2;
      if (_w + pref[m].first <= 3 * W / 2) {
        l = m;
      } else {
        r = m;
      }
    }

    if (l == -1) {
      continue;
    }
    if (i == pref[l].second) {
      l = i - 1;
    }
    if (l == -1) {
      continue;
    }
    auto[__w, __c, __id] = B[l];
    if (_w + __w <= 3 * W / 2 && res < _c + __c) {
      res = _c + __c;
      resIds = {B[i].id, B[pref[l].second].id};
    }
  }

  sum = 0, w = 0;
  vector<int> ids;
  for (int i = 0; i < (int) A.size(); i++) {
    if (w + A[i].w <= 3 * W / 2) {
      w += A[i].w;
      sum += A[i].c;
      ids.push_back(A[i].id);
    }
    if (res == sum) {
      resIds = ids;
      break;
    }
    res = max(res, sum);

    int l = -1, r = (int) pref.size();
    while (r - l > 1) {
      int m = (l + r) / 2;

      if (pref[m].first + w <= 3 * W / 2) {
        l = m;
      } else {
        r = m;
      }
    }

    if (l != -1) {
      if (res == sum + B[pref[l].second].c) {
        ids.push_back(B[pref[l].second].id);
        resIds = ids;
        break;
      }
    }
  }

  return {res, resIds};
}

void stress() {
  while (true) {
    gen();
    auto[a, ids] = solve();
    auto b = slow_solve();
    if (a < b) {
      cout << n << " " << W << endl;
      for (auto[w, c] : v) {
        cout << w << " " << c << endl;
      }
      cout << a << endl;
      cout << b << endl;
      exit(0);
    } else {
      if (set<int>(ids.begin(), ids.end()).size() != ids.size()) {
        cout << "NO";
        exit(0);
      }

    }
    cout << "YES" << endl;
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
//  stress();

  int test;
  cin >> test;
  while (test--) {
    read();
    auto[res, ids] = solve();
    cout << ids.size() << "\n";
    for (int id : ids) {
      cout << id + 1 << " ";
    }
    cout << "\n";
  }

  return 0;
}
