/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

// #define _GLIBCXX_DEBUG
// #define DEBUG 1

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()

using pii = pair<int, int>;

int cnt = 0;

void solve() {
	int n0, n = 0;
	int64_t W;
	cin >> n0 >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n0);
	forn(i, n0) {
		cin >> a[n].w >> a[n].cost, a[n].id = i;
		if (a[n].w <= W)
			n++;
	}
	a.resize(n);

	sort(all(a), [](auto a, auto b) {
		return a.w < b.w;
	});

	int LOG = 1;
	while ((1 << LOG) <= n)
		LOG++;
	vector<vector<pii>> sparse(LOG, vector<pii>(n));

	forn(i, n)
		sparse[0][i] = {a[i].cost, i};

	for (int k = 1; k < LOG; k++)
		for (int i = 0; i + (1 << k) <= n; i++)
			sparse[k][i] = max(sparse[k - 1][i], sparse[k - 1][i + (1 << (k - 1))]);

	vector<int> k(n + 1);
	for (int i = 2; i <= n; i++)
		k[i] = k[i / 2] + 1;

	// [l, r)
	auto get_min = [&](int l, int r) {
		int k1 = k[r - l];
		return max(sparse[k1][l], sparse[k1][r - (1 << k1)]);
	};	

	vector<int> ids, ans;
	int64_t best = 0;
	function<void(int, int64_t, int64_t)> go = [&](int i, int64_t sum_w, int64_t sum_cost) {
		if (i == n || sum_w + a[i].w > W) {
			if (best < sum_cost)
				best = sum_cost, ans = ids;
			return;
		}
		if (i + 1 == n || sum_w + a[i].w + a[i + 1].w > W) {
			int j = upper_bound(a.begin() + i, a.begin() + n, Item {(int)(W - sum_w), 0, 0}, [](Item a, Item b) {
				return a.w < b.w;
			}) - a.begin();
			// [i, j)
			// assert(j > i);
			// assert(a[j - 1].w + sum_w <= W);
			auto m = get_min(i, j);
			if (best < sum_cost + m.first) {
				best = sum_cost + m.first;
				ans = ids;
				// assert(i <= m.second);
				// assert(m.second < j);
				ans.push_back(a[m.second].id);
			}
			return;
		}
		cnt++;
		go(i + 1, sum_w, sum_cost);
		ids.push_back(a[i].id);
		go(i + 1, sum_w + a[i].w, sum_cost + a[i].cost);
		ids.pop_back();
	};
	go(0, 0, 0);

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
	cerr << cnt << "\n";
}
