/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 *
 * This solution takes only sets with sum w_i <= W.
 * Purpose of this solution : check optimality of jury-answers to knapsack-problem
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

const int CNT1 = 5;
const int CNT2 = 3;
const int CNT3 = 3;
const int CNT4 = 5;
const int CNT5 = 5;

void solve() {
	int n0, n = 0;
	int64_t W;
	cin >> n0 >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n0);
	forn(i, n0) {
		cin >> a[n].w >> a[n].cost, a[n].id = i;
		if (a[n].w <= W)
			n++;
	}
	a.resize(n);

	sort(all(a), [](auto a, auto b) {
		return (int64_t)a.cost * b.w > (int64_t)b.cost * a.w;
	});
	vector<int> pos(n0);
	forn(i, n)
		pos[a[i].id] = i;

	auto tmp = a;
	vector<int> candidates;
	auto add = [&](int i) { 
		// printf("%d ", i);
		candidates.push_back(i);
	};
	auto block = [&](const char *) {
		// printf("\n%s: ", s);
	};

	// add max cost
	sort(all(tmp), [](auto a, auto b) {	return a.cost > b.cost;	});
	block("max cost");
	forn(i, min(CNT1, n)) 
		add(tmp[i].id);

	// add max weight and min weight >= W/2
	block("max weight and min weight >= W/2");
	sort(all(tmp), [](auto a, auto b) {	return a.w < b.w; });
	int first = 0;
	while (first < n && tmp[first].w * 2 <= W)
		first++;
	for (int i = first; i < n; i++)
		if (i - first < CNT2 || n - i <= CNT2)
			add(tmp[i].id);

	// add worst by greedy
	block("worst by greedy");
	forn(i, min(n, CNT3))
		add(a[n - i - 1].id);

	int64_t best = 0;
	vector<int> ans;

	vector<Item> skipped;
	auto relax = [&](bool f = 0) {
		int64_t sum_w = 0, sum_cost = 0;
		vector<int> ids;
		forn(i, n)
			if (sum_w + a[i].w <= W) {
				sum_w += a[i].w;
				sum_cost += a[i].cost;
				ids.push_back(a[i].id);
			} else if (f) {
				skipped.push_back(a[i]);
			}
		if (sum_cost > best)
			best = sum_cost, ans = ids;
	};
	relax(1);
	block("skipped max cost/w");
	forn(i, min(sz(skipped), CNT4))
		add(skipped[i].id);
	block("skipped max cost");
	sort(all(skipped), [](auto a, auto b) {
		return a.cost > b.cost;
	});
	forn(i, min(sz(skipped), CNT5))
		add(skipped[i].id);
	block("done");
	for (int id : candidates) {
		int x = pos[id];
		rotate(a.begin(), a.begin() + x, a.begin() + x + 1);
		relax();
		rotate(a.begin(), a.begin() + 1, a.begin() + x + 1); // rotate back
	}

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
