/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

void solve() {
	int n0, n = 0;
	int64_t W;
	cin >> n0 >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n0);
	forn(i, n0) {
		cin >> a[n].w >> a[n].cost, a[n].id = i;
		if (a[n].w <= W)
			n++;
	}
	a.resize(n);

	sort(all(a), [](auto a, auto b) {
		return (int64_t)a.cost * b.w > (int64_t)b.cost * a.w;
	});
	vector<int> pos(n0);
	forn(i, n)
		pos[a[i].id] = i;

	vector<int> candidates;
	auto add = [&](int i) { 
		candidates.push_back(i);
	};

	int64_t best = 0;
	vector<int> ans;
	vector<Item> skipped;

	auto relax = [&]() {
		int64_t sum_w = 0, sum_cost = 0;
		vector<int> ids;
		forn(i, n)
			if (sum_w + a[i].w <= 3 * W / 2) {
				sum_w += a[i].w;
				sum_cost += a[i].cost;
				ids.push_back(a[i].id);
			} else {
				skipped.push_back(a[i]);
			}
		if (sum_cost > best)
			best = sum_cost, ans = ids;
	};
	relax();

	// add max cost among skipped
	sort(all(skipped), [](auto a, auto b) {	return a.cost > b.cost;	});
	forn (i, min(sz(skipped), 5))
		add(skipped[i].id);

	for (int id : candidates) {
		int x = pos[id];
		rotate(a.begin(), a.begin() + x, a.begin() + x + 1);
		relax();
		rotate(a.begin(), a.begin() + 1, a.begin() + x + 1); // rotate back
	}

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
